//
//  LoadingView.m
//  MoontanRoad
//
//  Created by 홍승욱 on 13. 1. 9..
//  Copyright (c) 2013년 홍승욱. All rights reserved.
//

#import "LoadingView.h"
#import <QuartzCore/QuartzCore.h>

@interface LoadingView() {
    UIImageView *_loadingBar;
    NSTimer *_timer;
    double _angle;
    
    id _goHomeTarget;
    SEL _goHomeAction;
}
@end

@implementation LoadingView

- (id)initWithFrame:(CGRect)frame withGoHomeBtnTarget:(id)target withGoHomeBtnAction:(SEL)action
{
    self = [super initWithFrame:frame];
    if (self) {
        
        _goHomeTarget = target;
        _goHomeAction = action;
        
        [self setBackgroundColor:RGBA(0x33, 0x33, 0x33, 0.7)];
        [self.layer setCornerRadius:5.0f];
        [self.layer setBorderColor:[RGB(0x33, 0x33, 0x33) CGColor]];
        [self.layer setBorderWidth:2.0f];
        
//        UIView *bgView = [[UIView alloc] initWithFrame:CGRectMake((self.bounds.size.width-100)/2, (self.bounds.size.height-80)/2, 100, 80)];
        
//        UIImageView *titleView = [[UIImageView alloc] initWithFrame:CGRectMake(66.25, 80, 187.5, 95.5)];
//        [titleView setImage:[UIImage imageNamed:@"loading_title.png"]];
//        [self addSubview:titleView];
//        [titleView release];

        CGSize loadingBarSize = CGSizeMake(30, 30);
        _loadingBar = [[UIImageView alloc] initWithFrame:CGRectMake(40, 5, loadingBarSize.width, loadingBarSize.height)];
        [_loadingBar setImage:[UIImage imageNamed:@"loading.png"]];
        [self addSubview:_loadingBar];
        
        UILabel *lbLoading = [[UILabel alloc] initWithFrame:CGRectMake(80, 5, 155, 30)];
        [lbLoading setBackgroundColor:[UIColor clearColor]];
        [lbLoading setText:@"로딩중..."];
        [lbLoading setTextColor:[UIColor whiteColor]];
        [lbLoading setFont:[UIFont boldSystemFontOfSize:18.0f]];
        [lbLoading setIsAccessibilityElement:YES];
        [self addSubview:lbLoading];
//        [lbLoading release];
        
        UIButton *btnGoHome = [UIButton buttonWithType:UIButtonTypeCustom];
        [btnGoHome setFrame:CGRectMake(10, 40, 180, 38.5)];
        [btnGoHome setImage:[UIImage imageNamed:@"btn_home.png"] forState:UIControlStateNormal];
        [btnGoHome setImage:[UIImage imageNamed:@"btn_home_on.png"] forState:UIControlStateHighlighted];
        [btnGoHome setIsAccessibilityElement:YES];
        [btnGoHome setAccessibilityHint:@"처음으로"];
        [btnGoHome addTarget:self action:@selector(btnGoHome_clicked) forControlEvents:UIControlEventTouchUpInside];
        [self addSubview:btnGoHome];
        
        
//        timer = [NSTimer scheduledTimerWithTimeInterval:0.05 target:self selector:@selector(loadingBarChange:) userInfo:nil repeats:YES];
        _angle = 0;
    }
    return self;
}

- (void)setHidden:(BOOL)hidden
{
    [super setHidden:hidden];
    if (hidden) {
        if (_timer != nil) {
            [_timer invalidate];
            _timer = nil;
        }
    }
    else {
        if (_timer == nil) {
            _timer = [NSTimer scheduledTimerWithTimeInterval:0.05 target:self selector:@selector(loadingBarChange:) userInfo:nil repeats:YES];
            _angle = 0;
        }
    }
}

- (void)btnGoHome_clicked
{
    [self setHidden:YES];
    [_timer invalidate];
    _timer = nil;
    if([_goHomeTarget respondsToSelector:_goHomeAction]) {
        [_goHomeTarget performSelector:_goHomeAction];
    }
}

- (void)loadingBarChange:(NSTimer*)timer
{
    if ([self superview] == nil) {
        return;
    }
    _angle -= 0.5;
    if (_angle <= -6.2) {
        _angle = 0;
    }
    CGAffineTransform transform = CGAffineTransformMakeRotation(_angle);
    [_loadingBar setTransform:transform];
}

- (void)dealloc
{
    if([_timer isValid])
        [_timer invalidate];
//    [_loadingBar release];
//    [super dealloc];
}

@end
