package com.ubitec.smvcex;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import java.util.Locale;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.mybatis.spring.SqlSessionTemplate;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.datasource.DataSourceTransactionManager;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

/**
 * Handles requests for the application home page.
 */
@Controller
public class HomeController {
	
	private static final Logger logger = LoggerFactory.getLogger(HomeController.class);
	
	String ServerIP = "http://opendata.busan.go.kr/"; 
	//String ServerIP = "http://192.168.174.99:8080/";
	
	@Autowired
	commonSetting.SettingVals settingVals;
	
	@Autowired
    org.apache.commons.dbcp.BasicDataSource dataSource;
    @Autowired
    SqlSessionTemplate sqlSessionTemplate;
    @Autowired
    DataSourceTransactionManager transactionManager;
	
	/**
	 * Simply selects the home view to render by returning its name.
	 */	
	@RequestMapping(value = "/Busan", method = RequestMethod.GET)
	public String home(Locale locale, Model model) {
		logger.info("Welcome home! The client locale is {}.", locale);
		
		return "busan";
	}
	
	
	@RequestMapping(value = "/Busan2", method = RequestMethod.GET)
    public String getDBTest(Locale locale, Model model, HttpServletRequest hsrequest) {
        logger.info("Welcome home! The client locale is {}.", locale);
        

        return "sujawon";
    }
	@RequestMapping(value = "/Busan3", method = RequestMethod.GET)
    public String getBusan3(Locale locale, Model model, HttpServletRequest hsrequest) {

        

        return "sudo";
    }
	@RequestMapping(value = "/Busan4", method = RequestMethod.GET)
    public String getBusan4(Locale locale, Model model, HttpServletRequest hsrequest) {

        

        return "sudo2";
    }

	@RequestMapping(value = "/sudoXML", method = RequestMethod.GET)
    public void getsudoXML(HttpServletResponse response, HttpServletRequest request) {
                
    	response.setCharacterEncoding("utf-8");
        response.setContentType("text/xml; charset=utf-8");
        
        
        URLConnection conn;
        BufferedWriter bw;
        BufferedReader br;

        String url = ServerIP + "openapi/service/DailyWaterQualityService/rawWaterQuality";

        System.out.println(url);
        try {
        	conn = new URL(url).openConnection();
   	     
            br = new BufferedReader(new InputStreamReader(conn.getInputStream(), "UTF-8"));
            bw = new BufferedWriter(response.getWriter());
             
            String line = null;
            while( (line=br.readLine())!=null ){
                bw.write(line);
            }
            bw.close();	
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
    }
	
	@RequestMapping(value = "/sudoGYXML", method = RequestMethod.GET)
    public void getsudoGYXML(HttpServletResponse response, HttpServletRequest request) {
                
    	response.setCharacterEncoding("utf-8");
        response.setContentType("text/xml; charset=utf-8");
        
        
        URLConnection conn;
        BufferedWriter bw;
        BufferedReader br;

        String url = ServerIP + "openapi/service/DailyWaterQualityService/dailyIndustrialWaterQuality?numOfRows=50";

        System.out.println(url);
        try {
        	conn = new URL(url).openConnection();
   	     
            br = new BufferedReader(new InputStreamReader(conn.getInputStream(), "UTF-8"));
            bw = new BufferedWriter(response.getWriter());
             
            String line = null;
            while( (line=br.readLine())!=null ){
                bw.write(line);
            }
            bw.close();	
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
    }
	
	
		
		
	@RequestMapping(value = "/sudodetailXML", method = RequestMethod.GET)
    public void getsudodetailXML(HttpServletResponse response, HttpServletRequest request) {
                
    	response.setCharacterEncoding("utf-8");
        response.setContentType("text/xml; charset=utf-8");
        
        
        URLConnection conn;
        BufferedWriter bw;
        BufferedReader br;

        String url = ServerIP + "openapi/service/DailyWaterQualityService/cleanWaterQualityDetail?numOfRows=100";

        System.out.println(url);
        try {
        	conn = new URL(url).openConnection();
   	     
            br = new BufferedReader(new InputStreamReader(conn.getInputStream(), "UTF-8"));
            bw = new BufferedWriter(response.getWriter());
             
            String line = null;
            while( (line=br.readLine())!=null ){
                bw.write(line);
            }
            bw.close();	
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
   
    }

    @RequestMapping(value = "/sudoRawXML", method = RequestMethod.GET)
    public void getsudoRawXML(HttpServletResponse response, HttpServletRequest request) {
                
    	response.setCharacterEncoding("utf-8");
        response.setContentType("text/xml; charset=utf-8");
        
        
        URLConnection conn;
        BufferedWriter bw;
        BufferedReader br;

        String url = ServerIP + "openapi/service/DailyWaterQualityService/cleanWaterQuality";

        System.out.println(url);
        try {
        	conn = new URL(url).openConnection();
   	     
            br = new BufferedReader(new InputStreamReader(conn.getInputStream(), "UTF-8"));
            bw = new BufferedWriter(response.getWriter());
             
            String line = null;
            while( (line=br.readLine())!=null ){
                bw.write(line);
            }
            bw.close();	
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
   

    }
	@RequestMapping(value = "/BusanXML", method = RequestMethod.GET)
    public String getXML(HttpServletResponse response, HttpServletRequest request) {
                
    	response.setCharacterEncoding("utf-8");
        response.setContentType("text/xml; charset=utf-8");
        
        
        URLConnection conn;
        BufferedWriter bw;
        BufferedReader br;

        String url = ServerIP + "openapi/service/EnvironmentalRadiationInfoService/getEnvironmentalRadiationPlaceList?numOfRows=100";

        System.out.println(url);
        try {
        	conn = new URL(url).openConnection();
   	     
            br = new BufferedReader(new InputStreamReader(conn.getInputStream(), "UTF-8"));
            bw = new BufferedWriter(response.getWriter());
             
            String line = null;
            while( (line=br.readLine())!=null ){
                bw.write(line);
            }
            bw.close();	
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
        

        return "sujawon";
    }
	
	@RequestMapping(value = "/BusanXMLbang2", method = RequestMethod.GET)
    public String getXMLbang2(HttpServletResponse response, HttpServletRequest request) {
                
    	response.setCharacterEncoding("utf-8");
        response.setContentType("text/xml; charset=utf-8");
        
        
        URLConnection conn;
        BufferedWriter bw;
        BufferedReader br;
        String par = request.getParameter("seq");
        String numOfRows = request.getParameter("numOfRows");
        
        String url = ServerIP + "openapi/service/EnvironmentalRadiationInfoService/getEnvironmentalRadiationInfoDetail";
        boolean bFirst = true;
        if(par!=null){
        	if(bFirst){
        		url+="?";
        		bFirst = false;
        	}
        	else
        		url+="&";
        	url+="seq="+par;
        }
        if(numOfRows != null) {
        	if(bFirst){
        		url+="?";
        		bFirst = false;
        	}
        	else
        		url+="&";
        	url+="numOfRows=" + numOfRows;
        }
        
        System.out.println(url);
        try {
        	conn = new URL(url).openConnection();
   	     
            br = new BufferedReader(new InputStreamReader(conn.getInputStream(), "UTF-8"));
            bw = new BufferedWriter(response.getWriter());
             
            String line = null;
            while( (line=br.readLine())!=null ){
                bw.write(line);
            }
            bw.close();	
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
        

        return "sujawon";
    }
	
	@RequestMapping(value = "/BusanXMLAirByStation", method = RequestMethod.GET)
    public String getXMLAirByStation(HttpServletResponse response, HttpServletRequest request) {
                
    	response.setCharacterEncoding("utf-8");
        response.setContentType("text/xml; charset=utf-8");
        
        
        URLConnection conn;
        BufferedWriter bw;
        BufferedReader br;
        String par = request.getParameter("seq");
        String numOfRows = request.getParameter("numOfRows");
        String date_hour = request.getParameter("date_hour");
        String idx = request.getParameter("idx");
        
        String url = ServerIP + "openapi/service/AirQualityInfoService/getAirQualityInfoClassifiedByStation?numOfRows=21";
        boolean bFirst = false;
        if(par!=null){
        	if(bFirst) {
        		url+="?";
        		bFirst = false;
        	}
        	else
        		url+="&";
        	url+="seq="+par;
        }
        if(numOfRows != null) {
        	if(bFirst){
        		url+="?";
        		bFirst = false;
        	}
        	else
        		url+="&";
        	url+="numOfRows=" + numOfRows;
        }
        if(date_hour != null) {
        	if(bFirst){
        		url+="?";
        		bFirst = false;
        	}
        	else
        		url+="&";
        	url+="date_hour=" + date_hour;
        }
        if(idx != null) {
        	if(bFirst){
        		url+="?";
        		bFirst = false;
        	}
        	else
        		url+="&";
        	url+="item=" + idx;
        }
        
        System.out.println(url);
        try {
        	conn = new URL(url).openConnection();
   	     
            br = new BufferedReader(new InputStreamReader(conn.getInputStream(), "UTF-8"));
            bw = new BufferedWriter(response.getWriter());
             
            String line = null;
            while( (line=br.readLine())!=null ){
                bw.write(line);
            }
            bw.close();	
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
        

        return "sujawon";
    }
	@RequestMapping(value = "/BusanXMLRiverByStation", method = RequestMethod.GET)
    public void getXMLRiverByStation(HttpServletResponse response, HttpServletRequest request) {
                
    	response.setCharacterEncoding("utf-8");
        response.setContentType("text/xml; charset=utf-8");
        
        
        URLConnection conn;
        BufferedWriter bw;
        BufferedReader br;
        String par = request.getParameter("seq");
        String numOfRows = request.getParameter("numOfRows");
        String date_hour = request.getParameter("date_hour");
        String idx = request.getParameter("idx");
        
        //String url = ServerIP + "openapi/service/RiverQualityInfoService/getRiverQualityInfoStation?date_hour=150101";
        String url = ServerIP + "openapi/service/RiverQualityService/getRiverQualityStation?date_hour=150101";
        boolean bFirst = false;
        if(par!=null){
        	if(bFirst) {
        		url+="?";
        		bFirst = false;
        	}
        	else
        		url+="&";
        	url+="seq="+par;
        }
        if(numOfRows != null) {
        	if(bFirst){
        		url+="?";
        		bFirst = false;
        	}
        	else
        		url+="&";
        	url+="numOfRows=" + numOfRows;
        }
        if(date_hour != null) {
        	if(bFirst){
        		url+="?";
        		bFirst = false;
        	}
        	else
        		url+="&";
        	url+="date_hour=" + date_hour;
        }
        if(idx != null) {
        	if(bFirst){
        		url+="?";
        		bFirst = false;
        	}
        	else
        		url+="&";
        	url+="item=" + idx;
        }
        
        System.out.println(url);
        try {
        	conn = new URL(url).openConnection();
   	     
            br = new BufferedReader(new InputStreamReader(conn.getInputStream(), "UTF-8"));
            bw = new BufferedWriter(response.getWriter());
             
            String line = null;
            while( (line=br.readLine())!=null ){
                bw.write(line);
            }
            bw.close();	
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
 
    }
	@RequestMapping(value = "/BusanXMLRiverByItem", method = RequestMethod.GET)
    public void getXMLRiverByItem(HttpServletResponse response, HttpServletRequest request) {
                
    	response.setCharacterEncoding("utf-8");
        response.setContentType("text/xml; charset=utf-8");
        
        
        URLConnection conn;
        BufferedWriter bw;
        BufferedReader br;
        String par = request.getParameter("seq");
        String numOfRows = request.getParameter("numOfRows");
        String date_hour = request.getParameter("date_hour");
        String item = request.getParameter("item");
        
        String url = ServerIP + "openapi/service/RiverQualityService/getRiverQualityItem";
        boolean bFirst = true;
        if(par!=null){
        	if(bFirst) {
        		url+="?";
        		bFirst = false;
        	}
        	else
        		url+="&";
        	url+="seq="+par;
        }
        if(numOfRows != null) {
        	if(bFirst){
        		url+="?";
        		bFirst = false;
        	}
        	else
        		url+="&";
        	url+="numOfRows=" + numOfRows;
        }
        if(date_hour != null) {
        	if(bFirst){
        		url+="?";
        		bFirst = false;
        	}
        	else
        		url+="&";
        	url+="date_hour=" + date_hour;
        }
        if(item != null) {
        	if(bFirst){
        		url+="?";
        		bFirst = false;
        	}
        	else
        		url+="&";
        	url+="item=" + item;
        }
        
        System.out.println(url);
        try {
        	conn = new URL(url).openConnection();
   	     
            br = new BufferedReader(new InputStreamReader(conn.getInputStream(), "UTF-8"));
            bw = new BufferedWriter(response.getWriter());
             
            String line = null;
            while( (line=br.readLine())!=null ){
                bw.write(line);
            }
            bw.close();	
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
        

        
    }
	@RequestMapping(value = "/BusanXMLAirByItem", method = RequestMethod.GET)
    public String getXMLAirByItem(HttpServletResponse response, HttpServletRequest request) {
                
    	response.setCharacterEncoding("utf-8");
        response.setContentType("text/xml; charset=utf-8");
        
        
        URLConnection conn;
        BufferedWriter bw;
        BufferedReader br;
        String par = request.getParameter("seq");
        String numOfRows = request.getParameter("numOfRows");
        String date_hour = request.getParameter("date_hour");
        String item = request.getParameter("item");
        
        String url = ServerIP + "openapi/service/AirQualityInfoService/getAirQualityInfoClassifiedByItem";
        boolean bFirst = true;
        if(par!=null){
        	if(bFirst) {
        		url+="?";
        		bFirst = false;
        	}
        	else
        		url+="&";
        	url+="seq="+par;
        }
        if(numOfRows != null) {
        	if(bFirst){
        		url+="?";
        		bFirst = false;
        	}
        	else
        		url+="&";
        	url+="numOfRows=" + numOfRows;
        }
        if(date_hour != null) {
        	if(bFirst){
        		url+="?";
        		bFirst = false;
        	}
        	else
        		url+="&";
        	url+="date_hour=" + date_hour;
        }
        if(item != null) {
        	if(bFirst){
        		url+="?";
        		bFirst = false;
        	}
        	else
        		url+="&";
        	url+="item=" + item;
        }
        
        System.out.println(url);
        try {
        	conn = new URL(url).openConnection();
   	     
            br = new BufferedReader(new InputStreamReader(conn.getInputStream(), "UTF-8"));
            bw = new BufferedWriter(response.getWriter());
             
            String line = null;
            while( (line=br.readLine())!=null ){
                bw.write(line);
            }
            bw.close();	
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
        

        return "sujawon";
    }
	
}
